#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <hamsandwich>
#include <fakemeta>
#include <engine>
#include <fun>

#define START_SOUND    "DeagleMod/a_round_start.mp3"
#define START_SOUND2    "DeagleMod/b_round_start.mp3"
#define SOUND_KILL    "DeagleMod/kill.wav"
 
new g_MaxPlayers
new kill[33] 
new g_Seconds
new g_SecondsCvar
new iconstatus
new deagle_icons[33][32]

new vModel[2][] = {"models/DeagleMod/v_knife.mdl", "models/DeagleMod/v_deagle.mdl"}
new pModel[2][] = {"models/DeagleMod/p_knife.mdl", "models/DeagleMod/p_deagle.mdl"}  

new WORLD_MODEL[]    = "models/DeagleMod/w_deagle.mdl"

new OLDWORLD_MODEL[]    = "models/w_deagle.mdl"

new const PlayerT[ ] = "models/player/DeagleT/DeagleT.mdl"
new const PlayerTT[ ] = "models/player/DeagleT/DeagleTT.mdl"
new const PlayerCT[ ] = "models/player/DeagleCT/DeagleCT.mdl"
new const PlayerCTT[ ] = "models/player/DeagleCT/DeagleCTT.mdl"

public plugin_init( ) 
{
    register_plugin("DeagleMod" , "1.0", "xrekuy") 
    register_event("CurWeapon", "Event_CurWeapon", "be","1=1")
    register_forward(FM_SetModel, "fw_SetModel")
    register_event("ResetHUD","resetModel","b")
    register_forward(FM_Think, "fwThink")
    register_event("HLTV", "Event_HLTV_New_Round", "a", "1=0", "2=0")
    g_MaxPlayers = get_maxplayers()
    register_forward( FM_GetGameDescription, "FwdGameDesc" );
    RegisterHam(Ham_Killed, "player", "fw_PlayerKilled")
    RegisterHam(Ham_Spawn, "player", "fwHamPlayerSpawnPost", 1) 
    g_SecondsCvar = register_cvar("autorr_time","20.0")
    register_event("CurWeapon", "deagle_icon", "be", "1=1")
    register_event("DeathMsg", "event_death", "a")
    iconstatus = get_user_msgid("StatusIcon")
    RegisterHam(Ham_Spawn, "player", "strip_weapon", 1)
    new iEntity = create_entity( "func_buyzone" );
    
    if( iEntity ) {
        entity_set_size( iEntity, Float:{ -4096.0, -4096.0, -4096.0 }, Float:{ -4095.0, -4095.0, -4095.0 } );
        entity_set_int( iEntity, EV_INT_iuser1, 1337 );
    }  
}      
        
public plugin_precache() 
{       
        for(new i = 0; i < 2; i++) {
        precache_model(vModel[i])
        precache_model(pModel[i]) 
        }
        precache_model( PlayerT )
        precache_model( PlayerTT )
        precache_model( PlayerCT )
        precache_model( PlayerCTT )
        precache_model(WORLD_MODEL)
        precache_sound(START_SOUND)
        precache_sound(START_SOUND2)
        precache_sound(SOUND_KILL)
        new iEntity = create_entity( "func_buyzone" );
    
        if( iEntity ) {
        entity_set_size( iEntity, Float:{ -4096.0, -4096.0, -4096.0 }, Float:{ -4095.0, -4095.0, -4095.0 } );
        entity_set_int( iEntity, EV_INT_iuser1, 1337 );
        }
}
            
public Event_CurWeapon(id) 
{            
	if(read_data(2) == CSW_KNIFE) {
		set_pev(id, pev_viewmodel2, vModel[0])
    		set_pev(id, pev_weaponmodel2, pModel[0])
	}
	else if(read_data(2) == CSW_DEAGLE) {
		set_pev(id, pev_viewmodel2, vModel[1])
    		set_pev(id, pev_weaponmodel2, pModel[1])
	}
}

public resetModel(id) {
		new CsTeams:userTeam = cs_get_user_team(id)
		if (userTeam == CS_TEAM_T) cs_set_user_model(id, "DeagleT")
		else if(userTeam == CS_TEAM_CT) cs_set_user_model(id, "DeagleCT")
		else cs_reset_user_model(id)
}

public fwThink(iEnt)
{
    while((iEnt = engfunc(EngFunc_FindEntityByString, iEnt, "classname", "func_bomb_target")))
    engfunc(EngFunc_RemoveEntity, iEnt)
}

public fw_SetModel(entity, model[])
{
    if (!is_valid_ent(entity)) 
        return FMRES_IGNORED

    if (!equali(model, OLDWORLD_MODEL)) 
        return FMRES_IGNORED

    new className[33]

    entity_get_string(entity, EV_SZ_classname, className, 32)

    if (equal(className, "weaponbox") || equal(className, "armoury_entity") || equal(className, "deagle"))
    {
        entity_set_model(entity, WORLD_MODEL)
        return FMRES_SUPERCEDE
    }
    return FMRES_IGNORED
}

public Event_HLTV_New_Round()
    {
    new snd = random_num(0, 1);
    for (new i = 1; i <= g_MaxPlayers; i++) {
    if (!is_user_connected(i))
    continue;

    if (snd)
    client_cmd(0,"mp3 play sound/DeagleMod/a_round_start")
    else
    client_cmd(0,"mp3 play sound/DeagleMod/b_round_start")
    }
}

public FwdGameDesc( ) {
	static const GameName[ ] = "Deagle Mod 2.0";
	
	forward_return( FMV_STRING, GameName );
	
	return FMRES_SUPERCEDE;
}

public fw_PlayerKilled(victim, attacker, shouldgib)
{ 
         kill[attacker] += 1

         set_hudmessage(255, 255, 255, 0.15, 0.71, 0, 6.0, 0.0)
         show_hudmessage(attacker, "%d KILL", kill[attacker])
         client_cmd(0,"spk sound/DeagleMod/kill")
}

public fwHamPlayerSpawnPost(id)
{
         kill[id] = 0
}  

public game_commencing() {
	if (task_exists(41170))
		remove_task(41170)
	g_Seconds = floatround(get_pcvar_float(g_SecondsCvar))
	new param[32]
	set_task(1.0,"count_rr",41170,param,31,"b",0)	
}

public count_rr() {	
	g_Seconds--;
	set_hudmessage(255, 255, 255, -1.0, 0.4, 0, 6.0, 1.0)
	show_hudmessage(0, "Auto Game Restart %d seconds",g_Seconds)	
	if (g_Seconds == 0) {
		server_cmd("sv_restartround 1")	
		remove_task(41170)
              }
}

public deagle_icon(id) 
{
	remove_deagle_icon(id)
		
	if(is_user_bot(id))
		return
		
	static ideagle, deagle_sprite[16], deagle_color[3]
	ideagle = get_user_weapon(id)
	
	switch(ideagle) 
	{
		case CSW_DEAGLE:
		{
			deagle_sprite = "d_deagle"
			deagle_color = {255, 255, 255}
                            }
		case CSW_KNIFE:
		{
			deagle_sprite = "d_knife"
			deagle_color = {255, 255, 255}
		}
		default: 
		return
	}
	deagle_icons[id] = deagle_sprite
	
	message_begin(MSG_ONE,iconstatus,{0,0,0},id)
	write_byte(1) // status (0=hide, 1=show, 2=flash)
	write_string(deagle_icons[id]) // sprite name
	write_byte(deagle_color[0]) // red
	write_byte(deagle_color[1]) // green
	write_byte(deagle_color[2]) // blue
	message_end()
	
	return
}

public remove_deagle_icon(id) 
{
	message_begin(MSG_ONE,iconstatus,{0,0,0},id)
	write_byte(0) // status (0=hide, 1=show, 2=flash)
	write_string(deagle_icons[id])
	message_end()
}

public event_death() 
{
	new id = read_data(2)
	
	if(!is_user_bot(id))
	remove_deagle_icon(id)
}

public strip_weapon(id)
{            
             if( is_user_alive( id ) ) {
             strip_user_weapons(id)
             give_item(id,"weapon_knife")
             give_item(id,"weapon_deagle")
             cs_set_user_bpammo( id, CSW_DEAGLE, 50 );
             }   
}  
